<?php

/**
 * @file
 */

/**
 *
 */
function uc_worldcore_success() {
  return theme('worldcore_payment_success');
}

/**
 *
 */
function uc_worldcore_fail() {
  return theme('worldcore_payment_fail');
}

/**
 *
 */
function uc_worldcore_status() {

  global $base_path;

  drupal_add_http_header('Content-type', 'text/html; charset=UTF-8');

  $headers = apache_request_headers();
  $json_body = file_get_contents('php://input');
  $hash_check = strtoupper(hash('sha256', $json_body . variable_get('uc_worldcore_api_password', '')));
  // Hash checking.
  if ($headers['WSignature'] == $hash_check) {

    // Some code to confirm payment.
    $created = time();

    $decoded_response = json_decode($json_body, TRUE);

    $order = uc_order_load($decoded_response['invoiceId']);

    if ($order) {

      if ($decoded_response['status'] == 'Paid') {

        $comment = t('WorldCore track: @track ', array('@track ' => $decoded_response['track']));
        uc_payment_enter($decoded_response['invoiceId'], 'uc_worldcore', $decoded_response['amount'], $order->uid, NULL, $comment);
        uc_cart_complete_sale($order);
        uc_order_comment_save($decoded_response['invoiceId'], 0, t('WorldCore payment successful.'));

      }

    }

  }
  else {

    // Some code to log invalid payments.
    watchdog('WorldCore', 'Hash mismatch! ' . $headers['WSignature'] . ' vs. ' . $hash_check, array(), WATCHDOG_ERROR);

    die();

  }

}
